package com.example.demo.service;

import com.example.demo.entity.Member;
import com.example.demo.repository.MemberRepository;
import lombok.RequiredArgsConstructor;

import org.springframework.scheduling.annotation.Async;
import org.springframework.stereotype.Service;

import javax.transaction.Transactional;

@Service
@Transactional
@RequiredArgsConstructor
public class MemberService {

    private final MemberRepository memberRepository;

    public Member saveMember(Member member){
        validateDuplicatetMember(member);

        return memberRepository.save(member);
    }

    @Async
    private boolean validateDuplicatetMember(Member member){
        synchronized(memberRepository){
            Member findMember = memberRepository.findByEmail(member.getEmail());
            if(findMember != null){
                System.out.println("이미 가입된 회원입니다.");
                return false;
            }
            return true;
        }
    }
}
